// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0.If a copy of the MPL was not distributed with this
// file, You can obtain one at https ://mozilla.org/MPL/2.0/.

#ifndef ANGLEAXIS_H
#define ANGLEAXIS_H

#include "Angle.h"
#include "Direction.h"
#include "Quaternion.h"

namespace Passer {
namespace LinearAlgebra {

template <typename T>
class AngleAxis {
 public:
  AngleOf<T> angle;
  Direction<T> axis;

  AngleAxis();
  AngleAxis(AngleOf<T> angle, Direction<T> axis);
  AngleAxis(Quaternion q);
  AngleAxis(float angle, Vector3 axis);

  Quaternion ToQuaternion();

  Direction<T> GetSwing();
};

}  // namespace LinearAlgebra
}  // namespace Passer
using namespace Passer::LinearAlgebra;

#endif