// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0.If a copy of the MPL was not distributed with this
// file, You can obtain one at https ://mozilla.org/MPL/2.0/.

#ifndef DIRECTION_H
#define DIRECTION_H

#include "Angle.h"

namespace Passer {
namespace LinearAlgebra {

struct Vector3;

template <typename T>
class Direction {
 public:
  AngleOf<T> horizontalAngle;
  AngleOf<T> verticalAngle;

  Direction();
  Direction(AngleOf<T> horizontal, AngleOf<T> vertical);
  Direction(Vector3 v);

  const static Direction forward;
  const static Direction back;
  const static Direction up;
  const static Direction down;
  const static Direction left;
  const static Direction right;

  Vector3 ToVector3();
};

}  // namespace LinearAlgebra
}  // namespace Passer
using namespace Passer::LinearAlgebra;

#endif